clear
close all
clc


% N = 1, cnt = 20
for cnt=32 %1:160
    load dataN_1
    %cnt = 3;
    x_1= Position_total(:,1,cnt);
    y_1 = Position_total(:,2,cnt);
    
    xo = 12;
    yo = 150;
    figure(1)
    clf
    plot(x_1, y_1,'*')
    hold on
    plot(xo,yo,'rs','MarkerSize',10,'LineWidth',3)
    legend('Estimates', 'Actual Position')
    grid on
    xlabel('x axis (m)')
    ylabel('y axis (m)')
    
    % figure
    % for cnt = 1:1000
    %     plot(Position_total(:,1,cnt), Position_total(:,2,cnt),'*')
    %     A= (find(isnan(Position_total(:,1,cnt))));
    %     if isempty(A)
    %         A = 1001;
    %     end
    %     x = Position_total(1:(A-1),1,cnt);
    %     y = Position_total(1:(A-1),2,cnt);
    %     title([cnt,corr(x,y)])
    %     pause
    % end
    
    figure(2)
    clf
    
    
    
    
    load dataN_32
    x_32= Position_total(:,1,cnt);
    y_32 = Position_total(:,2,cnt);
    plot(x_32, y_32,'*')
    hold on
    plot(xo,yo,'rs','MarkerSize',10,'LineWidth',3)
    
    xlabel('x axis (m)')
    ylabel('y axis (m)')
    grid on
    
    legend('Estimates', 'Actual Position')
    xlabel('x axis (m)')
    ylabel('y axis (m)')
    A=isnan(x_32);
    [indx] =find(A==1);
    INDVEC = setdiff([1:1000],indx)
    %Analysis
    mx1 = mean(x_1(INDVEC))
    my1 = mean(y_1(INDVEC))
    mx32 = mean(x_32(INDVEC))
    my32 = mean(y_32(INDVEC))
    
    vx1 = var(x_1(INDVEC))
    vy1 = var(y_1(INDVEC))
    vx32 = var(x_32(INDVEC))
    vy32 = var(y_32(INDVEC))
    
    
    rho_1 = (mean(x_1(INDVEC).*y_1(INDVEC)) -mx1*my1)/sqrt(vx1*vy1)
    c_1 = corr(x_1(INDVEC),y_1(INDVEC));
    rho_32 = (mean(x_32(INDVEC).*y_32(INDVEC)) -mx32*my32)/sqrt(vx32*vy32)
    c_32 = corr(x_32(INDVEC),y_32(INDVEC));
    ReducedCorr_1 = corr(x_1(INDVEC(1:2:end-1)),y_1(INDVEC(2:2:end)))
    
    ReducedCorr_32 = corr(x_32(INDVEC(1:2:end-1)),y_32(INDVEC(2:2:end)))
    
    cnt
    
    [ax_1,bx_1]=hist(x_1(INDVEC),30);
    [ay_1,by_1]=hist(y_1(INDVEC),30);
    [ax_32,bx_32]=hist(x_32(INDVEC),30);
    [ay_32,by_32]=hist(y_32(INDVEC),30);
    r_1 =sqrt((x_1(INDVEC)-xo).*(x_1(INDVEC)-xo)+(y_1(INDVEC)-yo).*(y_1(INDVEC)-yo));
    r_32 =sqrt((x_32(INDVEC)-xo).*(x_32(INDVEC)-xo)+(y_32(INDVEC)-yo).*(y_32(INDVEC)-yo));
    
    [ar_1,br_1]=hist(r_1,50);
    [ar_32,br_32]=hist(r_32,50);
    
    Hx_1=jbtest(x_1(INDVEC))
    Hy_1=jbtest(y_1(INDVEC))
    
    Hx_32=jbtest(x_32(INDVEC))
    Hy_32=jbtest(y_32(INDVEC))
    
    figure(3)
    subplot(2,2,1)
    
    bar(bx_1,ax_1/sum(ax_1))
    grid on
    title('(a)')
    ylabel('Normalized Histogram')
    xlabel('x estimates (m)')
    axis([0,30,0,0.2])
    subplot(2,2,2)
    
    bar(by_1,ay_1/sum(ay_1),'r')
    title('(b)')
    ylabel('Normalized Histogram')
    xlabel('y estimates (m)')
    grid on
    axis([0,250,0,0.1])
    subplot(2,2,3)
    bar(bx_32,ax_32/sum(ax_32))
    title('(c)')
    ylabel('Normalized Histogram')
    xlabel('x estimates (m)')
    grid on
    axis([0,30,0,0.2])
    subplot(2,2,4)
    bar(by_32,ay_32/sum(ay_32),'r')
    title('(d)')
    ylabel('Normalized Histogram')
    xlabel('y estimates (m)')
    grid on
    axis([0,250,0,0.1])
    
    grid on
    figure(4)
    subplot(2,1,1)
    bar(br_1,ar_1/sum(ar_1))
    grid on
    title('(a)')
    ylabel('Normalized Histogram')
    xlabel('Radial estimation error (m)')
    
    axis([0,120,0,0.09])
    subplot(2,1,2)
    bar(br_32,ar_32/sum(ar_32),'r')
    %pause
    title('(b)')
    ylabel('Normalized Histogram')
    xlabel('Radial estimation error (m)')
    grid on
    axis([0,120,0,0.09])
    
        figure(5)
    subplot(2,1,1)
    plot(br_1,cumsum(ar_1/sum(ar_1)))
    grid on
    title('(a)')
    ylabel('Normalized Histogram')
    xlabel('Radial estimation error (m)')
    
    
    subplot(2,1,2)
    plot(br_32,cumsum(ar_32/sum(ar_32)),'r')
    %pause
    title('(b)')
    ylabel('Normalized Histogram')
    xlabel('Radial estimation error (m)')
    grid on
 
    
    inc = 0.01;
    inc_t = 1e-3;
    cntVEC = [0:inc:1000];
    cnt_ind = 1;theta = 0:inc_t:2*pi;
    for cnt = cntVEC
        
        f(cnt_ind)= 1/(2*pi*sqrt(vx32*vy32)*sqrt(1-c_32^2))*sum(cnt * exp(-1/(2*(1-(c_32^2)))*(((cnt* cos(theta)).^2)/(vx32)+((cnt* sin(theta)).^2)/(vy32)+(2*c_32*(cnt*cnt*sin(theta).*cos(theta)))/sqrt(vx32*vy32)))*inc_t);
        cnt_ind = cnt_ind + 1;
    end
end